<?php
//include "smilepay_respond.php";
/**
 * Plugin Name: SmilePay_Credit 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay Credit 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 4.2.0
 */
if(!defined("SMILEPAY_RESPONSE_DECLARE"))
{
    include "smilepay_respond.php";
}
add_action('plugins_loaded', 'SmilePaycredit_gateway_init', 0);
function SmilePaycredit_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }

    class WC_SmilePaycredit extends WC_Payment_Gateway {

        public $title;
        public $description;
        public $dcvc;
        public $Rvg2c;
        public $Order_OKmain;
        public $Verify_key;

        public function __construct() {
            $this->id = 'smilepaycredit';
            $this->icon = apply_filters('woocommerce_SmilePaycredit_icon', plugins_url('log/paycredit.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePaycredit', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
            $this->Rvg2c =  $this->settings['Rvg2c'];
			$this->Verify_key = $this->settings['Verify_key'];			
			$this->Order_OKmain = $this->settings['Order_OKmain'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePaycredit_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_'.$this->id, array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2bcr("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2bcr(' SmilePay uWd'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2bcr('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2bcr('SmilePay uWd úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2bcr('Iڤ覡'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bcr('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2bcr("SmilePay  uWd úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2bcr('ӮaN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Rvg2c' => array(
                    'title' => __(u2bcr('ӮaѼƽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayӮaѼƽX'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Verify_key' => array(
                    'title' => __(u2bcr('ӮaˬdX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayӮaˬdXAˬdXӮaxuIAPIvAнƻsöKJW'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Order_OKmain' => array(
                    'title' => __(u2bcr('q榨߫ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bcr('q榨ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
            );
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePaycredit_args($order) {
            global $woocommerce;

            $paymethod = 'credit';
            $order_id = $order->id;
			$post_status = $order->post_status;

            $SmilePaycredit_args = array(
                "dcvc" => $this->dcvc,
                'Rvg2c' => $this->Rvg2c,
                "payment_type" => $paymethod,
				"post_status" => $post_status,
                "od_sob" => $order_id,
                'Verify_key' => $this->Verify_key,				
				'Order_OKmain' => $this->Order_OKmain,
				"amt" => round($order->get_total()),
            );
            $SmilePaycredit_args = apply_filters('woocommerce_SmilePaycredit_args', $SmilePaycredit_args);
            return $SmilePaycredit_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P   credit
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
            $order = new WC_Order($order_id);
			
			// $order = &new WC_Order($order_id);
			
			$SmilePaycredit_args = $this->get_SmilePaycredit_args($order);
			$order_status=$SmilePaycredit_args['post_status'];
			
            //sb
            $smilepay_credit_pay_for_order =  WC()->session->get( 'smilepay_credit_pay_for_order');

            $shipping_method = @array_shift($order->get_shipping_methods());
            $shipping_method_id = $shipping_method['method_id'];
               
		if($order_status=='wc-pending' || $smilepay_credit_pay_for_order)
		{
            //--ystart
			$shipping_method= $order->get_shipping_method();
			$getc2cu="N";
            

			if($_REQUEST['storeid']==''&&$_REQUEST['Classif']!='A')
			{
				//if($shipping_method==u2bcr("tRt7-11¨f"))
				//if(file_exists("smilepayc2cup.php"))
                   // include_once("smilepayc2cup.php");
                if(class_exists('WC_Smilepayc2cu_Shipping_Method'))
                    $smilepay_c2cupobj= new WC_Smilepayc2cu_Shipping_Method();
                else
                    $smilepay_c2cupobj= null;

                //<b2c> start
                //if(file_exists("smilepayb2cup.php"))
                   // include_once("smilepayb2cup.php");
                if(class_exists('WC_Smilepayb2cu_Shipping_Method'))
                    $smilepay_b2cupobj = new WC_Smilepayb2cu_Shipping_Method();
                else
                    $smilepay_b2cupobj = null;
                //<b2c> end
              
                //ˬdyO_ϥί¨f
				if($smilepay_c2cupobj && $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
                {
                    if(WC_Smilepayc2cu_Shipping_Method::checkout_is_selected_emap($shipping_method_id))
                    {
                        $c2cstore_data = WC_Smilepayc2cu_Shipping_Method::checkout_load_storedata();
                        $c2c_storeaddress = $c2cstore_data['storeaddress'];
				        $c2c_storename = $c2cstore_data['storename'];
				        $c2c_storeid = $c2cstore_data['storeid'];
                        $getc2cu="Y";
                        $c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;	
                    }
                    else
                    {
                        if(is_ssl())
                            $URL = 'https://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        else
			                $URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        $mappurl = WC_Smilepayc2cu_Shipping_Method::getCSVMapUrl($shipping_method_id,$URL);
                    
                        header("Location: $mappurl"); 
					    exit();	
                    }
					
				}
                //<b2c> start
                elseif(  $smilepay_b2cupobj && $smilepay_b2cupobj->isSelectedSmilepayB2Cup($order_id))
                {

					if(WC_Smilepayb2cu_Shipping_Method::checkout_is_selected_emap($shipping_method_id))
                    {
                        $b2cstore_data = WC_Smilepayb2cu_Shipping_Method::checkout_load_storedata();
                        $b2c_storeaddress = $b2cstore_data['storeaddress'];
				        $b2c_storename = $b2cstore_data['storename'];
				        $b2c_storeid = $b2cstore_data['storeid'];
                        $getc2cu="Y";
                        $b2c_store=$b2c_storeid.'/'.$b2c_storename.'/'.$b2c_storeaddress;	
                        $b2c_run = true;
                    }
                    else
                    {
                        if(is_ssl())
                            $URL = 'https://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        else
			                $URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
                        $mappurl = WC_Smilepayb2cu_Shipping_Method::getCSVMapUrl($shipping_method_id,$URL);
                    
                        header("Location: $mappurl"); 
					    exit();	
                    }
				}
                //<b2c> end
			}
			else
			{
                if(class_exists('WC_Smilepayc2cu_Shipping_Method'))
                    $smilepay_c2cupobj = new WC_Smilepayc2cu_Shipping_Method();
                else
                    $smilepay_c2cupobj = null;
                if(class_exists('WC_Smilepayb2cu_Shipping_Method'))
                    $smilepay_b2cupobj = new WC_Smilepayb2cu_Shipping_Method();
                else
                    $smilepay_b2cupobj = null;
                //<b2c> start
                $b2c_run=false;

                if($smilepay_b2cupobj && $smilepay_b2cupobj->isSelectedSmilepayB2Cup($order_id))
                {

                    $b2c_storeaddress=$_REQUEST['address'];
				    $b2c_storename=$_REQUEST['storename'];
				    $b2c_storeid=$_REQUEST['storeid'];
                    $b2c_store=$b2c_storeid.'/'.$b2c_storename.'/'.$b2c_storeaddress;
                    $b2c_run = true;
                    //smilepay b2cup compatible emapdata
                    $b2cstore_data['storeid'] = $b2c_storeid;
                    $b2cstore_data['storename'] = $b2c_storename;
                    $b2cstore_data['storeaddress'] = $b2c_storeaddress;
                } 
                //<b2c> end
                else 
                {
				    $c2c_storeaddress=$_REQUEST['storeaddress'];
				    $c2c_storename=$_REQUEST['storename'];
				    $c2c_storeid=$_REQUEST['storeid'];
				    //smilepay c2cup compatible emapdata
                    $c2cstore_data['storeid'] = $c2c_storeid;
                    $c2cstore_data['storename'] = $c2c_storename;
                    $c2cstore_data['storeaddress'] = $c2c_storeaddress;
                    

				    $c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;		

                }
                $getc2cu="Y";	
			}
			//--yend
            //sb
            if( $smilepay_credit_pay_for_order)
            {
                WC()->session->__unset('smilepay_credit_pay_for_order');
            }
              
            
			//qܦᵲ
			$order->update_status('on-hold');	
			$ordertext = "<h1>O̥Iڤ</h1><br>ǳƶiJde";
			$order->add_order_note(u2bcr($ordertext), "0");

          	//}ҽuWd
			$QUERY_STRING_Value=$_SERVER['REQUEST_URI'];
			$PHP_SELF_Value = substr($QUERY_STRING_Value, 0 ,strpos($QUERY_STRING_Value,"?"));
			$QUERY_STRING_Value = parse_url($QUERY_STRING_Value,PHP_URL_QUERY);
			$QUERY_STRING_Array=mb_split("&",$QUERY_STRING_Value);
			$QUERY_STRING_Value="";
			foreach ($QUERY_STRING_Array as $value) {  
				if( strpos($value,"storeid") === 0 ){continue;}
				if( strpos($value,"storename") === 0 ){continue;}
				if( strpos($value,"storeaddress") === 0 ){continue;}
				if( strpos($value,"tempvar") === 0 ){continue;}
				if( strpos($value,"typesserver") === 0 ){continue;}
				$QUERY_STRING_Value=$value."&".$QUERY_STRING_Value;
			}
			if(substr($QUERY_STRING_Value, -1,1) =="&" )
			{$QUERY_STRING_Value=substr($QUERY_STRING_Value, 0,-1);}
			$REQUEST_URI_Value=$PHP_SELF_Value."?".$QUERY_STRING_Value;
				
			if (is_ssl())
				$URL = 'https://' . $_SERVER['HTTP_HOST'] . $REQUEST_URI_Value;
			else
				$URL = 'http://' . $_SERVER['HTTP_HOST'] . $REQUEST_URI_Value;

			if($getc2cu=="Y")
			{
                if($b2c_run) //<b2c> start
                    $Address=$b2c_store;
                else    //<b2c> end
                    $Address=$c2c_store;
            }
			else
			{$Address=$order->get_billing_address_1();}

			$pur_name = $order->get_billing_last_name() . $order->get_billing_first_name();
		//	$c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;
            //<SmilePay>item add start
            /*$products="";
            foreach ($order->get_items() as $key => $lineItem) {
                $products .= $lineItem['name'] ."*" .$lineItem['quantity'] .",";
            
            }
            $products=trim($products,",");*/
            //<SmilePay>item add end
            //smilepay c2cup save data by orderid
            if(  $smilepay_c2cupobj && $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
            {
                WC_Smilepayc2cu_Shipping_Method::_save_storedata_by_orderid($order_id,$c2cstore_data);
                WC_Smilepayc2cu_Shipping_Method::checkout_clear_store_data();
            }
            elseif($smilepay_b2cupobj && $smilepay_b2cupobj->isSelectedSmilepayB2Cup($order_id))//smilepay b2cup save data by orderid
            {
                WC_Smilepayb2cu_Shipping_Method::_save_storedata_by_orderid($order_id,$b2cstore_data);
                WC_Smilepayb2cu_Shipping_Method::checkout_clear_store_data();
            }   
			$cardurl =	'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp?'.
						'Dcvc=' . $SmilePaycredit_args['dcvc'] .
						'&Rvg2c=' .$SmilePaycredit_args['Rvg2c'] .
						'&Pur_name=' .urlencode($pur_name).
						'&Tel_number=' .urlencode($order->get_billing_phone()).
						'&Address=' .urlencode($Address).
						'&Email=' .urlencode($order->get_billing_email()).
						'&Data_id=' .$SmilePaycredit_args['od_sob'].
						'&od_sob=' . $SmilePaycredit_args['od_sob'].
						'&Amount=' . $SmilePaycredit_args['amt'].
						'&Deadline_date=' . $Deadline_date.
						'&Roturl_status=' . 'woook'.
                        '&Remark=woocommerce';
						//<SmilePay>item add start
					    //'&Remark='. $products;
                        //<SmilePay>item add end
			$post_strall=$cardurl.'&Pay_zg=1'.'&Roturl=' . urlencode($URL);

           
			header("Location: $post_strall"); 
			exit();	
		}		
		if($order_status=='wc-on-hold'&&$_REQUEST['Classif']=='A')
		{
			$A_Amount=$_REQUEST['Amount'];
			$A_Data_id=$_REQUEST['Data_id'];
			$A_Response_id=$_REQUEST['Response_id'];
			$A_Errdesc=$_REQUEST['Errdesc'];
			$A_Smseid=$_REQUEST['Smseid'];
			$A_date=$_REQUEST['Process_date'];
			$A_time=$_REQUEST['Process_time'];
			$A_Address=$_REQUEST['Address'];
            
            $title = b2ucr($this->title);
			if($A_Response_id=='1'&&$SmilePaycredit_args['amt']==$A_Amount)
			{
               
        		wc_reduce_stock_levels( $order_id );		
				$pay_ok="úO覡G<font color=red>$title</font><br>GG<font color=red>v\</font></br>vBG<font color=red>".
							$A_Amount."</font></br>ɶG<font color=red>".$A_date.$A_time."</font></br>";
				$order->add_order_note(u2bcr($pay_ok),"1");
				$ordertext="<h1>úOT</h1>úO覡G<font color=red>$title</font><br>GG<font color=red>v\</font></br>vBG<font color=red>".
							$A_Amount."</font></br>ɶG<font color=red>".$A_date." ".$A_time."</font></br>SmilePaylܽXG<font color=red>".$A_Smseid."</font>";
				$order->add_order_note(u2bcr($ordertext),"0");
				$order->update_status('processing');
				echo u2bcr($pay_ok);

                //if(file_exists("smilepayc2cup.php"))
				    //include_once("smilepayc2cup.php");
                if(class_exists('WC_Smilepayc2cu_Shipping_Method'))
                    $smilepay_c2cupobj= new WC_Smilepayc2cu_Shipping_Method();
                else
                    $smilepay_c2cupobj= null;

                //<b2c> start
                //if(file_exists("smilepayb2cup.php"))
                    //include_once("smilepayb2cup.php");
                if(class_exists('WC_Smilepayb2cu_Shipping_Method'))
                    $smilepay_b2cupobj = new WC_Smilepayb2cu_Shipping_Method();
                else
                    $smilepay_b2cupobj = null;
                //<b2c> end

                //ˬdyO_ϥί¨f
				if($smilepay_c2cupobj && $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
				{
					include "smilepay_function_c2c.php";
                    $pur_name = $order->get_billing_last_name() . $order->get_billing_first_name();
					$post_str = 'Dcvc=' . $SmilePaycredit_args['dcvc'] .
							'&Rvg2c=' . $SmilePaycredit_args['Rvg2c'] .
							'&Pur_name=' .$pur_name.
							'&Tel_number=' .$order->get_billing_phone().
							'&Email=' .$order->get_billing_email().
							'&Data_id=' . $SmilePaycredit_args['od_sob'].
							'&od_sob=' . $SmilePaycredit_args['od_sob'].
							'&Amount=' . $SmilePaycredit_args['amt'].
							'&Roturl_status=' . 'woook'.
							'&Verify_key=' . $SmilePaycredit_args['Verify_key'].
							'&Remark=woocommerce';
					$c2c_store=u2bcr($A_Address);
                    
					$scvurls=repeatc2c($c2c_store,$post_str,$SmilePaycredit_args['dcvc'],$SmilePaycredit_args['Verify_key'],$shipping_method_id);
					$order->add_order_note(u2bcr($scvurls),"0");

                    $c2c_store_array= explode("/",$c2c_store); 
                    if(!empty($c2c_store_array) && count($c2c_store_array)==3)
                    {
                        $c2c_storeid=$c2c_store_array[0];
                        $c2c_storename=$c2c_store_array[1];
                        $c2c_storeaddress=$c2c_store_array[2];
                    }
                    else
                    {
                        $c2c_storeid="";
                        $c2c_storename="";
                        $c2c_storeaddress="";
                    }
                    
                 
                    //<smilepay> modify address start 
                    if( !empty($c2c_storeid) && !empty($c2c_storename) && !empty($c2c_storeaddress))
                    {
                            $shipping_addr= $order->get_shipping_address_1();
                            $store_addr=$c2c_storeid ." " .$c2c_storename ." " .$c2c_storeaddress;
                            if($store_addr != $shipping_addr)
                            {
                             $order->set_shipping_address_1($store_addr);
                             $order->save();
                            }
                    }
                    //<smilepay> modify address end		

					$scvurls_1="fG<font color=red>(".b2ucr(WC_Smilepayc2cu_Shipping_Method::getCSVServiceName($shipping_method_id)).")".b2ucr($c2c_storename . $c2c_storeid)."</font><br>";
                    $scvurls_1 .= "a}G<font color=red>".b2ucr($c2c_storeaddress)."</font><br>";
                    $scvurls_1 .= "fHmWG<font color=red>".b2ucr($pur_name)."</font><br>";
                    $scvurls_1 .= "fHqܡG<font color=red>".b2ucr($order->get_billing_phone())."</font><br>";

					$order->add_order_note(u2bcr($scvurls_1),"1");
                    echo u2bcr('<h1>fT</h1>' . $scvurls_1);
				}
                elseif($smilepay_b2cupobj && $smilepay_b2cupobj->isSelectedSmilepayB2Cup($order_id))
				{
					include "smilepay_function_b2c.php";
                    $pur_name = $order->get_billing_last_name() . $order->get_billing_first_name();
					$post_str = 'Dcvc=' . $SmilePaycredit_args['dcvc'] .
							'&Rvg2c=' . $SmilePaycredit_args['Rvg2c'] .
							'&Pur_name=' .$pur_name.
							'&Tel_number=' .$order->get_billing_phone().
							'&Email=' .$order->get_billing_email().
							'&Data_id=' . $SmilePaycredit_args['od_sob'].
							'&od_sob=' . $SmilePaycredit_args['od_sob'].
							'&Amount=' . $SmilePaycredit_args['amt'].
							'&Roturl_status=' . 'woook'.
							'&Verify_key=' . $SmilePaycredit_args['Verify_key'].
							'&Remark=woocommerce';
					$b2c_store=u2bcr($A_Address);
                    
					$scvurls=repeatb2c($b2c_store,$post_str,$SmilePaycredit_args['dcvc'],$SmilePaycredit_args['Verify_key']);
					$order->add_order_note(u2bcr($scvurls),"0");

                    $b2c_store_array= explode("/",$b2c_store); 
                    if(!empty($b2c_store_array) && count($b2c_store_array)==3)
                    {
                        $b2c_storeid=$b2c_store_array[0];
                        $b2c_storename=$b2c_store_array[1];
                        $b2c_storeaddress=$b2c_store_array[2];
                    }
                    else
                    {
                        $b2c_storeid="";
                        $b2c_storename="";
                        $b2c_storeaddress="";
                    }
                    //<smilepay> modify address start 
                    if( !empty($b2c_storeid) && !empty($b2c_storename) && !empty($b2c_storeaddress))
                    {
                            $shipping_addr= $order->get_shipping_address_1();
                            $store_addr=$b2c_storeid ." " .$b2c_storename ." " .$b2c_storeaddress;
                            if($store_addr != $shipping_addr)
                            {
                             $order->set_shipping_address_1($store_addr);
                             $order->save();
                            }
                    }
                    //<smilepay> modify address end		
					$scvurls_1="fG<font color=red>(".b2ucr(WC_Smilepayb2cu_Shipping_Method::getCSVServiceName($shipping_method_id)).")".b2ucr($b2c_storename . $b2c_storeid)."</font><br>";
                    $scvurls_1 .= "a}G<font color=red>".b2ucr($b2c_storeaddress)."</font><br>";
                    $scvurls_1 .= "fHmWG<font color=red>".b2ucr($pur_name)."</font><br>";
                    $scvurls_1 .= "fHqܡG<font color=red>".b2ucr($order->get_billing_phone())."</font><br>";

					$order->add_order_note(u2bcr($scvurls_1),"1");
                    echo u2bcr('<h1>fT</h1>' . $scvurls_1);
				}
				
			}
			else
			{
                if($order_status=='wc-failed')
                {
                    echo u2bcr("<font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
                    return;
                }


				$pay_err="úO覡G<font color=red>uWd</font><br>GG<font color=red>v</font></br>ɶG<font color=red>".
							$A_date.$A_time."</font></br>ѭ]G<font color=red>".$A_Errdesc."</font></br>";
				$order->add_order_note(u2bcr($pay_err),"1");
				$ordertext="úO覡G<font color=red>uWd</font><br>GG<font color=red>v</font></br>ɶG<font color=red>".
							$A_date." ".$A_time."</font></br>ѭ]G<font color=red>".$A_Errdesc."</font></br>SmilePaylܽXG<font color=red>".$A_Smseid."</font>";
				$order->add_order_note(u2bcr($ordertext),"0");
				$order->update_status('failed');
				echo u2bcr($pay_err);
			}
			echo "<br><br>".$SmilePaycredit_args['Order_OKmain'];
		}
    }
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
			$order = new WC_Order( $order_id );

            if(is_null($this->dcvc) || empty($this->dcvc) ||
               is_null($this->Rvg2c) || empty($this->Rvg2c)
                )
            {
                wc_add_notice(u2bcr("<br>tRtӮaѼƿ~AлPӮapô<br>") , 'error' );
                return;
            }
			

            //sb
            if(isset($_REQUEST['pay_for_order']) && $_REQUEST['pay_for_order']=='true')
            {
                WC()->session->set( 'smilepay_credit_pay_for_order', true );
            }

            
			//--yend*/
            //wc_reduce_stock_levels( $order_id );
			WC()->cart->empty_cart();
			return array(
				'result' 	=> 'success',
				'redirect'	=> $this->get_return_url( $order )
			);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */
    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePaycredit_gateway($methods) {
        $methods[] = 'WC_SmilePaycredit';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePaycredit_gateway');
}
if(!function_exists('u2bcr'))
{
    function u2bcr($text)//eX
    {	return iconv("big5","UTF-8",$text);}
}

if(!function_exists('b2ucr'))
{
    function b2ucr($text)//gJƮw
    {	return iconv("UTF-8","big5",$text);}
}
?>